Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/create_bathy.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/create_bathy.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/create_bathy.f90	(revision 5213)
@@ -602,36 +741,36 @@
       ENDDO
 
-      !3-4 initialise variable with value
-      tl_var=var_init(TRIM(td_var%c_name),dl_value(:,:,:,:))
+      ! initialise variable with value
+      create_bathy_matrix=var_init(TRIM(td_var%c_name),dl_value(:,:,:,:))
 
       DEALLOCATE(dl_value)
 
-      !4- add ghost cell
-      CALL grid_add_ghost(tl_var,il_ighost,il_jghost)
-
-      !5- save result
-      create_bathy_matrix=tl_var
+      ! add ghost cell
+      CALL grid_add_ghost(create_bathy_matrix, il_xghost(:,:))
+
+      ! clean
+      CALL dim_clean(tl_dim(:))
 
    END FUNCTION create_bathy_matrix
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine
+   !> This function extract variable from file over coordinate domain and
+   !> return variable structure
    !> 
-   !> @details 
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
    !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
-   !> @param[in] 
+   !> @param[in] td_var    variable structure 
+   !> @param[in] td_mpp    mpp file structure
+   !> @param[in] td_coord  coordinate file structure
+   !> @return variable structure
    !-------------------------------------------------------------------
-   !> @code
-   FUNCTION create_bathy_extract(td_var, td_file, &
+   FUNCTION create_bathy_extract(td_var, td_mpp, &
    &                             td_coord)
       IMPLICIT NONE
       ! Argument
-      TYPE(TVAR) , INTENT(IN) :: td_var  
-      TYPE(TFILE), INTENT(IN) :: td_file
-      TYPE(TFILE), INTENT(IN) :: td_coord
+      TYPE(TVAR), INTENT(IN) :: td_var  
+      TYPE(TMPP), INTENT(IN) :: td_mpp
+      TYPE(TMPP), INTENT(IN) :: td_coord
 
       ! function
@@ -639,8 +778,5 @@
 
       ! local variable
-      INTEGER(i4), DIMENSION(2,2,2) :: il_ind
-
-      INTEGER(i4) :: il_pivot
-      INTEGER(i4) :: il_perio
+      INTEGER(i4), DIMENSION(2,2) :: il_ind
 
       INTEGER(i4) :: il_imin
@@ -648,6 +784,4 @@
       INTEGER(i4) :: il_imax
       INTEGER(i4) :: il_jmax
-
-      TYPE(TFILE) :: tl_file
 
       TYPE(TMPP)  :: tl_mpp
@@ -661,67 +795,42 @@
       !----------------------------------------------------------------
 
-      IF( td_file%i_id == 0 )THEN
-         CALL logger_error("CREATE BATHY EXTRACT: file "//&
-         &  TRIM(td_file%c_name)//" not opened ")
+      IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
+         CALL logger_error("CREATE BATHY EXTRACT: no processor associated "//&
+         &  "to mpp "//TRIM(td_mpp%c_name))
       ELSE
 
          !init
-         tl_file=td_file
-
-         !1- open file
-         CALL iom_open(tl_file)
-
-         ! get periodicity
-         il_pivot=grid_get_pivot(tl_file)
-         il_perio=grid_get_perio(tl_file,il_pivot)
-
-         tl_file%i_perio=il_perio
-
-         !2- compute file grid indices around coord grid
-         il_ind(:,:,:)=grid_get_coarse_index(tl_file, td_coord )
-
-         il_imin=il_ind(1,1,1) ; il_imax=il_ind(1,2,1)
-         il_jmin=il_ind(2,1,1) ; il_jmax=il_ind(2,2,1)
-
-         IF( ANY( il_ind(:,:,2) /= 0 ) )THEN
-            CALL logger_error("CREATE BATHY EXTRACT: something wrong "//&
-            &  " find offset when extracting data")
-         ENDIF
-         !3- check grid coincidence
-         CALL grid_check_coincidence( tl_file, td_coord, &
+         tl_mpp=mpp_copy(td_mpp)
+
+         ! compute file grid indices around coord grid
+         il_ind(:,:)=grid_get_coarse_index(tl_mpp, td_coord )
+
+         il_imin=il_ind(1,1) ; il_imax=il_ind(1,2)
+         il_jmin=il_ind(2,1) ; il_jmax=il_ind(2,2)
+
+         ! check grid coincidence
+         CALL grid_check_coincidence( tl_mpp, td_coord, &
          &                            il_imin, il_imax, &
          &                            il_jmin, il_jmax, &
          &                            (/1, 1, 1/) )
 
-         !4- compute domain
-         tl_dom=dom_init(tl_file,         &
+         ! compute domain
+         tl_dom=dom_init(tl_mpp,           &
          &               il_imin, il_imax, &
          &               il_jmin, il_jmax)
 
-         ! close file
-         CALL iom_close(tl_file)
-
-         !5- read bathymetry on domain (ugly way to do it, have to work on it)
-         !5-1 init mpp structure
-         tl_mpp=mpp_init(tl_file)
-
-         CALL file_clean(tl_file)
-
-         !5-2 get processor to be used
-         CALL mpp_get_use( tl_mpp, tl_dom )
-
-         !5-3 open mpp files
-         CALL iom_mpp_open(tl_mpp)
-
-         !5-4 read variable on domain
-         tl_var=iom_mpp_read_var(tl_mpp,TRIM(td_var%c_name),td_dom=tl_dom)
-
-         !5-5 close mpp file
-         CALL iom_mpp_close(tl_mpp)
-
-         !6- add ghost cell
-         CALL grid_add_ghost(tl_var,tl_dom%i_ighost,tl_dom%i_jghost)
-
-         !7- check result
+         ! open mpp files over domain
+         CALL iom_dom_open(tl_mpp, tl_dom)
+
+         ! read variable on domain
+         tl_var=iom_dom_read_var(tl_mpp,TRIM(td_var%c_name),tl_dom)
+
+         ! close mpp file
+         CALL iom_dom_close(tl_mpp)
+
+         ! add ghost cell
+         CALL grid_add_ghost(tl_var,tl_dom%i_ghost(:,:))
+
+         ! check result
          IF( ANY( tl_var%t_dim(:)%l_use .AND. &
          &        tl_var%t_dim(:)%i_len /= td_coord%t_dim(:)%i_len) )THEN
@@ -743,18 +852,19 @@
          ENDIF
 
-         !8- add attribute to variable
+         ! add attribute to variable
          tl_att=att_init('src_file',TRIM(fct_basename(tl_mpp%c_name)))
          CALL var_move_att(tl_var, tl_att)         
 
-         tl_att=att_init('src_i-indices',(/tl_dom%i_imin, tl_dom%i_imax/))
+         tl_att=att_init('src_i_indices',(/tl_dom%i_imin, tl_dom%i_imax/))
          CALL var_move_att(tl_var, tl_att)
 
-         tl_att=att_init('src_j-indices',(/tl_dom%i_jmin, tl_dom%i_jmax/))
+         tl_att=att_init('src_j_indices',(/tl_dom%i_jmin, tl_dom%i_jmax/))
          CALL var_move_att(tl_var, tl_att)
 
-         !9- save result
-         create_bathy_extract=tl_var
+         ! save result
+         create_bathy_extract=var_copy(tl_var)
 
          ! clean structure
+         CALL att_clean(tl_att)
          CALL var_clean(tl_var)
          CALL mpp_clean(tl_mpp)
@@ -762,24 +872,23 @@
 
    END FUNCTION create_bathy_extract
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine
+   !> This function get coarse grid variable, interpolate variable, and return
+   !> variable structure over fine grid
    !> 
-   !> @details 
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
    !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
-   !> @param[in] td_var : variable structure
-   !> @param[in] td_file : file structure
-   !> @param[in] id_imin : i-direction lower left  corner indice 
-   !> @param[in] id_imax : i-direction upper right corner indice 
-   !> @param[in] id_jmin : j-direction lower left  corner indice
-   !> @param[in] id_jmax : j-direction upper right corner indice 
-   !> @param[in] id_rho  : table of refinement factor
+   !> @param[in] td_var    variable structure
+   !> @param[in] td_mpp    mpp file structure
+   !> @param[in] id_imin   i-direction lower left  corner indice 
+   !> @param[in] id_imax   i-direction upper right corner indice 
+   !> @param[in] id_jmin   j-direction lower left  corner indice
+   !> @param[in] id_jmax   j-direction upper right corner indice 
+   !> @param[in] id_offset offset between fine grid and coarse grid
+   !> @param[in] id_rho    array of refinement factor
+   !> @return variable structure
    !-------------------------------------------------------------------
-   !> @code
-   FUNCTION create_bathy_get_var(td_var, td_file,  &
+   FUNCTION create_bathy_get_var(td_var, td_mpp,   &
             &                    id_imin, id_jmin, &
             &                    id_imax, id_jmax, &
@@ -789,5 +898,5 @@
       ! Argument
       TYPE(TVAR) , INTENT(IN) :: td_var  
-      TYPE(TFILE), INTENT(IN) :: td_file  
+      TYPE(TMPP) , INTENT(IN) :: td_mpp 
       INTEGER(i4), INTENT(IN) :: id_imin
       INTEGER(i4), INTENT(IN) :: id_imax
@@ -801,107 +910,91 @@
 
       ! local variable
-      INTEGER(i4) :: il_pivot
-      INTEGER(i4) :: il_perio
-
-      TYPE(TFILE) :: tl_file
-
       TYPE(TMPP)  :: tl_mpp
-
       TYPE(TATT)  :: tl_att
-
       TYPE(TVAR)  :: tl_var
-      
       TYPE(TDOM)  :: tl_dom
+
+      INTEGER(i4) :: il_size
+      INTEGER(i4), DIMENSION(:), ALLOCATABLE :: il_rho
 
       ! loop indices
       !----------------------------------------------------------------
       IF( ANY(SHAPE(id_offset(:,:)) /= 2) )THEN
-         CALL logger_error("CREATE BATHY GET VAR: invalid dimensio of "//&
-         &                 "offset table")
+         CALL logger_error("CREATE BATHY GET VAR: invalid dimension of "//&
+         &                 "offset array")
       ENDIF
 
-      !init
-      tl_file=td_file
-
-      !1- open file
-      CALL iom_open(tl_file)
-
-      ! get periodicity
-      il_pivot=grid_get_pivot(tl_file)
-      il_perio=grid_get_perio(tl_file,il_pivot)
-
-      tl_file%i_perio=il_perio
-
-      !2- compute domain
-      tl_dom=dom_init(tl_file,          &
+      ! copy structure
+      tl_mpp=mpp_copy(td_mpp)
+
+      !- compute domain
+      tl_dom=dom_init(tl_mpp,           &
       &               id_imin, id_imax, &
       &               id_jmin, id_jmax)
 
-      CALL dom_print(tl_dom)
-      print *,'id_offset ',id_offset(:,:)
-      !3- close file
-      CALL iom_close(tl_file)      
-
-      !4- add extra band (if possible) to compute interpolation
+      !- add extra band (if possible) to compute interpolation
       CALL dom_add_extra(tl_dom)
 
-      !5- read bathymetry on domain (ugly way to do it, have to work on it)
-      !5-1 init mpp sturcutre
-      tl_mpp=mpp_init(tl_file)
-
-      CALL file_clean(tl_file)
-
-      !5-2 get processor to be used
-      CALL mpp_get_use( tl_mpp, tl_dom )
-
-      !5-3 open mpp files
-      CALL iom_mpp_open(tl_mpp)
-
-      !5-4 read variable value on domain
-      tl_var=iom_mpp_read_var(tl_mpp,TRIM(td_var%c_name),td_dom=tl_dom)
-
-      !5-5 close mpp files
-      CALL iom_mpp_close(tl_mpp)      
-
-      !6- interpolate variable
-      CALL create_bathy_interp(tl_var, id_rho(:), id_offset(:,:))
-
-      !7- remove extraband added to domain
-      CALL dom_del_extra( tl_var, tl_dom, id_rho(:) )
-
-      !8- add ghost cell
-      CALL grid_add_ghost(tl_var,tl_dom%i_ighost,tl_dom%i_jghost)
+      !- open mpp files over domain
+      CALL iom_dom_open(tl_mpp, tl_dom)
+
+      !- read variable value on domain
+      tl_var=iom_dom_read_var(tl_mpp,TRIM(td_var%c_name),tl_dom)
+
+      !- close mpp files
+      CALL iom_dom_close(tl_mpp)
+
+      il_size=SIZE(id_rho(:))
+      ALLOCATE( il_rho(il_size) )
+      il_rho(:)=id_rho(:)
+      
+      !- interpolate variable
+      CALL create_bathy_interp(tl_var, il_rho(:), id_offset(:,:))
+
+      !- remove extraband added to domain
+      CALL dom_del_extra( tl_var, tl_dom, il_rho(:) )
+
+      !- add ghost cell
+      CALL grid_add_ghost(tl_var,tl_dom%i_ghost(:,:))
  
-      !9- add attribute to variable
+      !- add attribute to variable
       tl_att=att_init('src_file',TRIM(fct_basename(tl_mpp%c_name)))
       CALL var_move_att(tl_var, tl_att)
 
-      tl_att=att_init('src_i-indices',(/tl_dom%i_imin, tl_dom%i_imax/))
+      tl_att=att_init('src_i_indices',(/tl_dom%i_imin, tl_dom%i_imax/))
       CALL var_move_att(tl_var, tl_att)
 
-      tl_att=att_init('src_j-indices',(/tl_dom%i_jmin, tl_dom%i_jmax/))
+      tl_att=att_init('src_j_indices',(/tl_dom%i_jmin, tl_dom%i_jmax/))
       CALL var_move_att(tl_var, tl_att)
 
-      !10- save result
-      create_bathy_get_var=tl_var
-
-      !11- clean structure
+      IF( .NOT. ALL(id_rho(:)==1) )THEN
+         tl_att=att_init("refinment_factor",(/id_rho(jp_I),id_rho(jp_J)/))
+         CALL var_move_att(tl_var, tl_att)
+      ENDIF
+
+      DEALLOCATE( il_rho )
+
+      !- save result
+      create_bathy_get_var=var_copy(tl_var)
+
+      !- clean structure
+      CALL att_clean(tl_att)
+      CALL var_clean(tl_var)
       CALL mpp_clean(tl_mpp)
  
    END FUNCTION create_bathy_get_var
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine
+   !> This subroutine interpolate variable
    !> 
-   !> @details 
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
    !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !>
-   !> @param[in] 
-   !> @todo 
+   !> @param[inout] td_var variable structure 
+   !> @param[in] id_rho    array of refinment factor
+   !> @param[in] id_offset array of offset between fine and coarse grid
+   !> @param[in] id_iext   i-direction size of extra bands (default=im_minext)
+   !> @param[in] id_jext   j-direction size of extra bands (default=im_minext)
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE create_bathy_interp( td_var,         &
    &                               id_rho,          &
@@ -919,5 +1012,4 @@
 
       ! local variable
-      TYPE(TVAR)  :: tl_var
       TYPE(TVAR)  :: tl_mask
 
@@ -929,7 +1021,4 @@
       ! loop indices
       !----------------------------------------------------------------
-
-      ! copy variable
-      tl_var=td_var
 
       !WARNING: two extrabands are required for cubic interpolation
@@ -952,60 +1041,55 @@
       ENDIF
 
-      !1- work on mask
-      !1-1 create mask
-      ALLOCATE(bl_mask(tl_var%t_dim(1)%i_len, &
-      &                tl_var%t_dim(2)%i_len, &
-      &                tl_var%t_dim(3)%i_len, &
-      &                tl_var%t_dim(4)%i_len) )
+      ! work on mask
+      ! create mask
+      ALLOCATE(bl_mask(td_var%t_dim(1)%i_len, &
+      &                td_var%t_dim(2)%i_len, &
+      &                td_var%t_dim(3)%i_len, &
+      &                td_var%t_dim(4)%i_len) )
 
       bl_mask(:,:,:,:)=1
-      WHERE(tl_var%d_value(:,:,:,:)==tl_var%d_fill) bl_mask(:,:,:,:)=0      
-
-      SELECT CASE(TRIM(tl_var%c_point))
+      WHERE(td_var%d_value(:,:,:,:)==td_var%d_fill) bl_mask(:,:,:,:)=0      
+
+      SELECT CASE(TRIM(td_var%c_point))
       CASE DEFAULT ! 'T'
-         tl_mask=var_init('tmask', bl_mask(:,:,:,:), td_dim=tl_var%t_dim(:))
-      CASE('U')
-         tl_mask=var_init('umask', bl_mask(:,:,:,:), td_dim=tl_var%t_dim(:))
-      CASE('V')
-         tl_mask=var_init('vmask', bl_mask(:,:,:,:), td_dim=tl_var%t_dim(:))
-      CASE('F')
-         tl_mask=var_init('fmask', bl_mask(:,:,:,:), td_dim=tl_var%t_dim(:))
+         tl_mask=var_init('tmask', bl_mask(:,:,:,:), td_dim=td_var%t_dim(:), &
+         &                id_ew=td_var%i_ew )
+      CASE('U','V','F')
+         CALL logger_fatal("CREATE BATHY INTERP: can not computed "//&
+         &                 "interpolation on "//TRIM(td_var%c_point)//&
+         &                 " grid point (variable "//TRIM(td_var%c_name)//&
+         &                 "). check namelist.")
       END SELECT
 
       DEALLOCATE(bl_mask)
 
-      !1-2 interpolate mask
+      ! interpolate mask
       CALL interp_fill_value( tl_mask, id_rho(:), &
       &                       id_offset=id_offset(:,:) )
 
-      !2- work on variable
-      !2-0 add extraband
-      CALL extrap_add_extrabands(tl_var, il_iext, il_jext)
-
-      !2-1 extrapolate variable
-      CALL extrap_fill_value( tl_var, id_offset=id_offset(:,:), &
+      ! work on variable
+      ! add extraband
+      CALL extrap_add_extrabands(td_var, il_iext, il_jext)
+
+      ! extrapolate variable
+      CALL extrap_fill_value( td_var, id_offset=id_offset(:,:), &
       &                               id_rho=id_rho(:),         &
       &                               id_iext=il_iext, id_jext=il_jext )
 
-      !2-2 interpolate Bathymetry
-      CALL interp_fill_value( tl_var, id_rho(:), &
+      ! interpolate Bathymetry
+      CALL interp_fill_value( td_var, id_rho(:), &
       &                       id_offset=id_offset(:,:) )
 
-      !2-3 remove extraband
-      CALL extrap_del_extrabands(tl_var, il_iext*id_rho(jp_I), il_jext*id_rho(jp_J))
-
-      !2-2-5 keep original mask 
+      ! remove extraband
+      CALL extrap_del_extrabands(td_var, il_iext*id_rho(jp_I), il_jext*id_rho(jp_J))
+
+      ! keep original mask 
       WHERE( tl_mask%d_value(:,:,:,:) == 0 )
-         tl_var%d_value(:,:,:,:)=tl_var%d_fill
+         td_var%d_value(:,:,:,:)=td_var%d_fill
       END WHERE
-
-      !3- save result
-      td_var=tl_var
 
       ! clean variable structure
       CALL var_clean(tl_mask)
-      CALL var_clean(tl_var)
 
    END SUBROUTINE create_bathy_interp
-   !> @endcode
 END PROGRAM create_bathy
